





unit fos;



INTERFACE

USES struct,dos;

const
  Kleur      : ARRAY [0..7] OF BYTE = (30,34,32,36,31,35,33,37);
  NewLine    = #13+#10;

VAR
  Key          : CHAR;
  dummy        :string[1];
  IoRes        : WORD;
  I            : INTEGER;
  LOCAL        : BOOLEAN;
  ComPort      : WORD;
  ReturnChar   : CHAR;
  Rapad        : String;
  Nodenr       : Byte;
  Configrec    : ConfigRecord;
  Erec         : ExitInfoRecord;
  ExitFile     : FILE OF ExitInfoRecord;
  Configfile   : FILE OF ConfigRecord;
  Baud         : Word;
  dirro        : String;


PROCEDURE Delay(T:WORD);         {replacement for the ctr delay}
FUNCTION CarrierGood :BOOLEAN;   {returns if there still is a carrier}
                                 {you don't have to call this yourself}


FUNCTION RKeyPushed : BOOLEAN;   {has the remote pushed a key}
FUNCTION LKeyPushed :BOOLEAN;    {has the local side pushed a key?}
FUNCTION KeyPressed : BOOLEAN;   {either of 'm?}
FUNCTION Rkey : BOOLEAN;
FUNCTION Lkey : BOOLEAN;
FUNCTION GetRChar :CHAR;         {get remote character}
FUNCTION GetLChar :CHAR;         {get local character}
FUNCTION ReadKey : CHAR;         {get either remote or local character}
FUNCTION InitFossil : WORD;      {should always be called}
PROCEDURE fHangup;
PROCEDURE De_InitFossil;         {should always be called}
PROCEDURE FlushRbuffer;          {flush remote buffer}
PROCEDURE Fwrite(Str:STRING);    {local and remote write, can only display strings}
FUNCTION COLOR(F,B:BYTE):STRING; {returns string ansi code (f = foreground B= background}
FUNCTION GoXY(X,Y:BYTE):STRING;  {returns string ansi goxy code}
PROCEDURE ClearScreen;           {clears the screen, remote and local}
FUNCTION i2s(int:longint):string; {integer to string converter}
FUNCTION w2s(int:word):string;   {word to string converter}
FUNCTION Fill(St:STRING;Siz:BYTE;Links:BOOLEAN):STRING; {expand a string with spaces  (left or right}
FUNCTION Nul(St:STRING):STRING;              {don't know anymore}
FUNCTION Fread(Currentstr:String;X,Y,Max,F,B:Byte) : STRING;

         {readlb=n with edit option, place to start, editting colors, max string length}


implementation



PROCEDURE Delay(T:WORD);
VAR
  Uur,Min,Sec,Hu : WORD;
  HundrB,HundrE  : LONGINT;

BEGIN
  HundrE:=0;
  GetTime(Uur,Min,Sec,Hu);
  HundrB:=(Uur*360000)+(Min*6000)+(Sec*100)+Hu;
  WHILE (HundrE<HundrB+T) and (not keypressed) DO
    BEGIN
      GetTime(Uur,Min,Sec,Hu);
      HundrE:=(Uur*360000)+(Min*6000)+(Sec*100)+Hu;
    END;
END;


FUNCTION CarrierGood :BOOLEAN;
LABEL StillThere,Hangup,Einde;
BEGIN
    ASM
      XOR  AX,AX
      MOV  AH,03h
      MOV  DX,ComPort
      INT  14h
      TEST AL,10000000b
      JE   Stillthere
      JMP  Hangup
  StillThere:
      MOV @Result,00h
      JMP Einde
  Hangup:
      MOV @RESULT,01h
  Einde:
    END;
END;



procedure FHangUp;assembler;
asm
		mov	ax,0600h
                mov     dx,Comport
                int	14h
end;


{this routine is called in many routines. Which means you don't have to
 worry about carrierloss; However, before the HALT statement you might
 want to add some code which closes any open files you have at that moment
 or something else which has to be done before the program halts}


PROCEDURE CHECKCARRIER;

BEGIN
  IF (NOT CarrierGood) AND (NOT LOCAL) THEN
    BEGIN
      LOCAL := TRUE;
      Clearscreen;
      WRITELN(' BUMMER! User hanged up on ya ');
      de_initfossil;
      HALT;
    END;
END;





FUNCTION RKeyPushed : BOOLEAN;
LABEL Leeg,NietLeeg,Einde;
BEGIN
  ASM
    MOV AH,0Ch
    MOV DX,ComPort
    INT 14h
    CMP AX,0FFFFh
    JE  Leeg
    JMP NietLeeg
  Leeg:
    MOV @Result,00
    JMP Einde
  NietLeeg:
    MOV @Result,01
  Einde:
  END;
  CheckCarrier;
END;


FUNCTION LKeyPushed :BOOLEAN;
LABEL Leeg,NietLeeg,Einde;
BEGIN
  ASM
     MOV AH,0Bh
     INT 21h
     CMP AL,00h
     JE  Leeg
     JMP NietLeeg
   Leeg:
     MOV @Result,00h
     JMP Einde
   NietLeeg:
     MOV @RESULT,01h
   Einde:
  END;
  CheckCarrier;
END;


FUNCTION KeyPressed : BOOLEAN;
BEGIN
  IF (NOT CarrierGood) AND (NOT LOCAL) THEN
    BEGIN
      LOCAL := TRUE;
      Clearscreen;
      WRITELN(' CARRIER LOST! ');
      de_initfossil;
      HALT;
    END;
  IF Local THEN
    KeyPressed:=LkeyPushed
  ELSE
  Keypressed:=(LkeyPushed OR Rkeypushed);
END;

FUNCTION Rkey : BOOLEAN;
BEGIN
  IF (NOT CarrierGood) AND (NOT LOCAL) THEN
    BEGIN
      LOCAL := TRUE;
      Clearscreen;
      WRITELN(' CARRIER LOST! ');
      de_initfossil;
      HALT;
    END;
  IF Local THEN
    Rkey := LkeyPushed
  ELSE
  Rkey := Rkeypushed ;
END;

FUNCTION Lkey : BOOLEAN;
BEGIN
  IF (NOT CarrierGood) AND (NOT LOCAL) THEN
    BEGIN
      LOCAL := TRUE;
      Clearscreen;
      WRITELN(' CARRIER LOST! ');
      de_initfossil;
      HALT;
    END;
  IF Local THEN
    Lkey := LkeyPushed
  ELSE
  Lkey := LkeyPushed ;
END;

FUNCTION GetRChar :CHAR;
BEGIN
  ASM
    MOV AH,02h
    MOV DX,ComPort
    INT 14h
    MOV @Result,AL
  END
END;


FUNCTION GetLChar :CHAR;
BEGIN
  ASM
    MOV AH,08h
    INT 21h
    MOV @Result,AL
  END;
END;



{looks very weird, but it works.

 returns: Cursor-up   : #200
          Cursor-down : #208  (or the other way around ;)

 normals keys get the appropiate ascii value. EXCEPT keys which return
 two digits (like F1 through F12) they get value #255.

 I haven't had any use for those keys, so I didn't implent them, it
 shouldn't give you a hard time implenting them. Just don't mess with
 the delays....(man...it was irritating to find the right delay }


FUNCTION ReadKey : CHAR;
VAR
  KKK : Char;
  KK:byte;
BEGIN
  IF LOCAL THEN
    BEGIN
     REPEAT UNTIL LKeyPushed;
     KKK:=GetLChar
    END
  ELSE
    BEGIN
      REPEAT
      UNTIL LkeyPushed OR RKeyPushed;
      IF Lkeypushed THEN
        KKK:=GetLChar
      ELSE KKK:=GetRChar;
    END;
  IF (KKK=#27) THEN
    BEGIN
      IF NOT RkeyPushed THEN
        delay(25);
      IF Rkeypushed THEN
        BEGIN
          KKK:=GetRChar;
          IF NOT Rkeypushed THEN
            delay(25);
          IF Rkeypushed THEN
            BEGIN
              IF (KKK='[') AND (Rkeypushed) THEN
                BEGIN
                  KKK:=GetRChar;
                  CASE KKK OF
                     'A' :KKK:=#200;
                     'B' :KKK:=#208;
                     'C' :KKK:=#204;
                     'D' :KKK:=#206;

                    ELSE KKK:=#255
                  END;
                END;
            END;
        END;
    END;

  IF (KKK=#0) AND (LkeyPushed OR RKeyPushed) THEN
    BEGIN
      IF LKeyPushed THEN
         KKK:=GetLChar
      ELSE
         KKK:=GetRChar;
      CASE KKK OF

         #8  :KKK:=#207;
         #20 :KKK:=#209;
         #27 :KKK:=#27;
         #36 :KKK:=#211;
         #46 :KKK:=#210;
         #72 :KKK:=#200;
         #75 :KKK:=#206;
         #77 :KKK:=#204;
         #80 :KKK:=#208;
         #83 :KKK:=#205;
         #254:KKK:=#254;
        ELSE KKK:=#255
      END;
    END;

  ReadKey:=KKK;

END;


FUNCTION InitFossil : WORD;
BEGIN
  ASM
    MOV AH,04h
    MOV DX,ComPort
    INT 14h
    MOV @Result,Ax
  END;
END;

PROCEDURE De_InitFossil; ASSEMBLER;
ASM
  MOV AH,05h
  MOV dx,ComPort
  INT 14h
END;

PROCEDURE FlushRbuffer; ASSEMBLER;
ASM
  MOV AH,08h
  MOV DX,ComPort
  INT 14h
END;


PROCEDURE Fwrite(Str:STRING);

PROCEDURE WChar(Fchar:CHAR); ASSEMBLER;
ASM
  MOV AH,01h
  MOV AL,Fchar
  MOV DX,ComPort
  INT 14h
END;

VAR
  T : BYTE;

BEGIN
  CheckCarrier;
  FOR T:=1 TO Length(Str) DO
    BEGIN
      Write(Str[T]);
      IF NOT Local THEN
        Wchar(Str[T]);
    END;
END;


FUNCTION COLOR(F,B:BYTE):STRING;
VAR
  Tstr : STRING;
BEGIN
  IF F>7 THEN
    BEGIN
      Tstr:='1;';
      Dec(F,8);
    END
  ELSE Tstr:='0;';
  Tstr:=Tstr+i2s(kleur[f])+';'+i2s(kleur[b]+10)+'m';
  Color:='['+Tstr;
END;


FUNCTION GoXY(X,Y:BYTE):STRING;
BEGIN
  GoXY:='['+i2s(Y)+';'+i2s(X)+'H';
END;



PROCEDURE ClearScreen;
BEGIN
  FWrite('[0m[2J');
END;


FUNCTION i2s(int:longint):string;
VAR
  Tstr : STRING;
BEGIN
  str(int,Tstr);
  i2s:=Tstr;
END;


FUNCTION w2s(int:word):string;
VAR
  Tstr : STRING;
BEGIN
  str(int,Tstr);
  w2s:=Tstr;
END;

FUNCTION Fill(St:STRING;Siz:BYTE;Links:BOOLEAN):STRING;
VAR
  Tstr : STRING;
BEGIN
  Tstr:=St;
  WHILE LEngth(Tstr)<Siz DO
    IF Links THEN
      Tstr:=' '+Tstr
    ELSE
      Tstr:=Tstr+' ';
  Fill:=Tstr;
END;



FUNCTION Nul(St:STRING):STRING;
BEGIN
  IF Length(St)<2 THEN
    Nul:='0'+St
  ELSE
    Nul:=St;
END;

FUNCTION Fread(Currentstr:String;X,Y,Max,F,B:Byte) : STRING;
VAR
  Tempstr    : String;
  Currentpos : Byte;
  Finished   : Boolean;
  Key        : Char;


BEGIN
  Tempstr := Currentstr;
  currentpos := Length(Tempstr);
  ReturnChar := #0;
  Finished := False;
  Fwrite(Goxy(X,Y));
  fwrite(color(f,b));
  Fwrite(Tempstr);
  While not Finished do
    begin
      Key := Readkey;
      case key of
         #8  :begin
                If Currentpos>0 then
                  begin
                    Dec(Currentpos);
                    fwrite(Goxy(x+Currentpos,Y));
                    Fwrite(' ');
                    fwrite(Goxy(x+Currentpos,Y));
                    Tempstr := Copy(Tempstr,1,length(tempstr)-1);
                  end
              end;
         #13 :begin
                Finished := True;
                Returnchar := #13;
              end;
         #27 :begin
                Finished := True;
                ReturnChar := #27;
              end;
         #200,#208,#255 : BEGIN END;
         ELSE
           If length(Tempstr) < Max then
             begin
               Tempstr := Tempstr + Key;
               Inc(currentpos);
               Fwrite(key);
             end;
      End; {Case}
    end; {while}
    Fread := Tempstr;
end;




BEGIN
  VAL(paramstr(1),nodenr,i);
  VAL(Paramstr(2),ComPort,i);

  IF (((I<>0) AND (ParamCount=0)) OR( NodeNr=0)) THEN
    BEGIN
      Writeln(' No parameter supplied or incorrect parameter');
      Writeln(' Startup as menu type 7 : PROGRAMNAME.EXE *N *P');
      Writeln('                          PROGRAMNAME.EXE <Nodenr> <Comport>');
      Writeln;
      Halt;
    END;

  RaPad:=GetEnv('RA');
  IF RaPad[Length(RaPad)]<>'\' THEN
    RaPad:=RaPad+'\';

  ASSIGN(ConfigFile,RaPad+'CONFIG.RA');
  {$I-} RESET(ConfigFile); {$I+}
  IF IOresult <> 0 THEN
    Begin
      Writeln(' Error while reading CONFIG.RA, halting ');
      Halt;
    End;

  READ(ConfigFile,Configrec);
  CLOSE(ConfigFile);
  ComPort:=Comport-1;

  If InitFossil<>$1954 THEN
    begin
      writeln(' Error during fossil installation','fossildriver');
      halt;
    end;


  Baud:=Erec.baud;
  Local:=(Baud=0);

END.


